commit d0ceb8e276e282a2c9e08eb295ca5c9678d54c63
Author: Joel Hutton <joel.hutton@arm.com>
Date:   Wed Sep 30 16:20:55 2020 +0100

    [SLP][VECT] Add check to fix 96827
    
    The following patch adds a simple check to prevent slp stmts from
    vector constructors being rearranged. vect_attempt_slp_rearrange_stmts
    tries to rearrange to avoid a load permutation.
    
    This fixes PR target/96827
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=96827
    
    gcc/ChangeLog:
    
    2020-09-29  Joel Hutton  <joel.hutton@arm.com>
    
            PR target/96827
            * tree-vect-slp.c (vect_analyze_slp): Do not call
            vect_attempt_slp_rearrange_stmts for vector constructors.
    
    gcc/testsuite/ChangeLog:
    
    2020-09-29  Joel Hutton  <joel.hutton@arm.com>
    
            PR target/96827
            * gcc.dg/vect/bb-slp-49.c: New test.
    
    (cherry picked from commit 97b798d80baf945ea28236eef3fa69f36626b579)

diff --git a/gcc/testsuite/gcc.dg/vect/bb-slp-49.c b/gcc/testsuite/gcc.dg/vect/bb-slp-49.c
new file mode 100644
index 00000000000..e7101fcff46
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/vect/bb-slp-49.c
@@ -0,0 +1,28 @@
+/* This checks that vectorized constructors have the correct ordering. */
+/* { dg-require-effective-target vect_int } */
+
+typedef int V __attribute__((__vector_size__(16)));
+
+__attribute__((__noipa__)) void
+foo (unsigned int x, V *y)
+{
+  unsigned int a[4] = { x + 0, x + 2, x + 4, x + 6 };
+  for (unsigned int i = 0; i < 3; ++i)
+    if (a[i] == 1234)
+      a[i]--;
+  *y = (V) { a[3], a[2], a[1], a[0] };
+}
+
+int
+main ()
+{
+  V b;
+  foo (0, &b);
+  if (b[0] != 6 || b[1] != 4 || b[2] != 2 || b[3] != 0)
+    __builtin_abort ();
+  return 0;
+}
+
+/* See that we vectorize an SLP instance.  */
+/* { dg-final { scan-tree-dump "Analyzing vectorizable constructor" "slp1" } } */
+/* { dg-final { scan-tree-dump "vectorizing stmts using SLP" "slp1" } } */
diff --git a/gcc/tree-vect-slp.c b/gcc/tree-vect-slp.c
index 3fdf56f9335..3a8bbeaf657 100644
--- a/gcc/tree-vect-slp.c
+++ b/gcc/tree-vect-slp.c
@@ -1960,7 +1960,8 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
   /* Reduction (there are no data-refs in the root).
      In reduction chain the order of the loads is not important.  */
   if (!STMT_VINFO_DATA_REF (stmt_info)
-      && !REDUC_GROUP_FIRST_ELEMENT (stmt_info))
+      && !REDUC_GROUP_FIRST_ELEMENT (stmt_info)
+      && !SLP_INSTANCE_ROOT_STMT (slp_instn))
     vect_attempt_slp_rearrange_stmts (slp_instn);
 
   /* In basic block vectorization we allow any subchain of an interleaving

